static void writewebstats(char *chan)
{
  char buf[512], *pbuf;
  globstats *gs;

  sprintf(buf, "%s", chan);
  pbuf = buf;
  if (chan[0] == 0) {
    buf[0] = 0;
    for (gs = sdata; gs; gs = gs->next)
      sprintf(buf, "%s %s", buf, gs->chan);
    pbuf = buf;
    pbuf++;
  }
  while (strlen(pbuf) > 0)
    write_webstats(newsplit(&pbuf), S_TOTAL);
}

static void write_webstats(char *chan, int today)
{
  globstats *gs;
  locstats *ls;
  char what[512], what2[512], *pwhat, *pwhat2, *type, *type2, s[512], s2[512], ts[61];
  int itype, itype2, nr;
  struct userrec *u;
  time_t tt, ttbuf;
  FILE *f;

  Context;
  ttbuf = now;
  if (!today)
    debug1("Writing webstats for %s...", chan);
  if (write_today && !today)
    write_webstats(chan, 1);
  if (webdir[strlen(webdir) - 1] == '/')
    webdir[strlen(webdir) - 1] = 0;
  gs = findglobstats(chan);
  if (!gs) {
    putlog(LOG_MISC, "*", "Stats.mod: Can't write webstats for %s, no stats found.", chan);
    return;
  }
  sprintf(what, "%s", webstats);
  pwhat = what;
  while (strlen(pwhat) > 0) {
    type = newsplit(&pwhat);
    itype = typetoi(type);
    if (itype < 0) {
      putlog(LOG_MISC, "*", "Stats.mod: Error writing webfiles, unsupported type %s. Skipping.", type);
      continue;
    }
    sprintf(s, "%s/%s%s_%s%s%s~new", webdir, webfiles, chan + 1, type, today ? "_today" : "", webfile_suffix);
    sprintf(s2, "%s/%s%s_%s%s%s", webdir, webfiles, chan + 1, type, today ? "_today" : "", webfile_suffix);
    f = fopen(s, "w");
    chmod(s, 0644);
    if (f == NULL) {
      putlog(LOG_MISC, "*", "ERROR writing webstats. (%s)", s);
      return;
    }
    fprintf(f, "<html><head><title>Top %d talkers %son channel %s</title>\n",
            webnr, today ? "today " : "", chan);
    if (webupdate > 0)
      fprintf(f, "<META http-equiv=\"Refresh\" content=%d>\n", webupdate * 60);
    fprintf(f, "<META Name=\"Stats.mod\" Content=\"%s\">\n", MODULE_VERSION);
    fprintf(f, "<META Name=\"channel\" Content=\"%s\">\n", gs->chan);
    fprintf(f, "<META Name=\"network\" Content=\"%s\">\n", network);
    fprintf(f, "<META Name=\"written\" Content=\"%lu\">\n", now);
    fprintf(f, "<meta http-equiv=\"expires\" content=\"0\">\n");
    fprintf(f, "</head>\n");
    fprintf(f, "%s", bodytag);
    fprintf(f, "<center><h1>Top %d talkers %son channel %s</h1>", webnr,
            today ? "today " : "", chan);
    fprintf(f, "Ordered by \"%s\" (to change it click corresponding table field).<BR>", type);
    fprintf(f, "User peak: %d<BR>\n", gs->peak[today]);
    fprintf(f, "<P><table border=2 cellpadding=1><tr align=right>");
    fprintf(f, "<th>No</th>");
    fprintf(f, "<th align=center>Nick</th>");
    sprintf(what2, "%s", webstats);
    pwhat2 = what2;
    while (strlen(pwhat2) > 0) {
      type2 = newsplit(&pwhat2);
      itype2 = typetoi(type2);
      if (itype2 == T_MINUTES)
        fprintf(f, "<th><a href=\"%s%s_%s%s%s\">%s</a></th>\n", webfiles,
                chan + 1, type2, today ? "_today" : "", webfile_suffix,
                "time spent");
      else
        fprintf(f, "<th><a href=\"%s%s_%s%s%s\">%s</a></th>\n", webfiles,
                chan + 1, type2, today ? "_today" : "", webfile_suffix,
                type2);
    }
    sortstats(gs, type, today);
    nr = 0;
    for (ls = gs->local; ls; ls = ls->next) {
      u = get_user_by_handle(userlist, ls->user);
      if (matchattr(u, nostats, chan))
        continue;
      if ((itype >= 0) && !ls->values[today][itype])
        break;
      nr++;
      if (nr > webnr)
        break;
      fprintf(f, "<tr align=right><td>%d</td><td allign=center>%s</td>", nr,
              ls->user);
      sprintf(what2, "%s", webstats);
      pwhat2 = what2;
      while (strlen(pwhat2) > 0) {
        type2 = newsplit(&pwhat2);
        itype2 = typetoi(type2);
        if ((itype2 < 0) && (itype2 != T_WPL))
          continue;
        if (itype2 == T_MINUTES)
          fprintf(f, "<td>%s</td>", duration(ls->values[today][itype2] * 60));
        else if (itype2 == T_WPL) {
	  if (ls->values[today][T_LINES])
            fprintf(f, "<td>%.2f</td>", (float) ls->values[today][T_WORDS] / (float) ls->values[today][T_LINES]);
          else
            fprintf(f, "<td>0</td>");
        } else
          fprintf(f, "<td>%d</td>", ls->values[today][itype2]);
      }
      fprintf(f, "</tr>\n");
    }
    fprintf(f, "<tr>");
    fprintf(f, "<td colspan=%d align=center>", countwords(webstats) + 2);
    fprintf(f, "<b>Total users: %d", countstatmembers(gs));
    fprintf(f, "</B></td></tr>");
    fprintf(f, "<tr><td colspan=%d align=center><A HREF=\"%s%s_graphs%s%s\">graphs</A></td></tr>",
            countwords(webstats) + 2, webfiles, chan + 1,
            today ? "_today" : "", webfile_suffix);
    if (write_today) {
      if (today)
        fprintf(f, "<tr><td colspan=%d align=center><A HREF=\"%s%s_words%s\">total stats</A></td></tr>",
                countwords(webstats) + 2, webfiles, chan + 1, webfile_suffix);
      else
        fprintf(f, "<tr><td colspan=%d align=center><A HREF=\"%s%s_words_today%s\">stats of today</A></td></tr>",
                countwords(webstats) + 2, webfiles, chan + 1, webfile_suffix);
    }
    fprintf(f, "</table><br>");
    tt = now;
    strftime(ts, 60, "%d.%m. %Y  %H:%M", localtime(&tt));
    fprintf(f, "Created %s by <a href=\"http://www.visions-of-fantasy.de/stats.mod/\">Stats.mod v%s</a>.<BR>", ts, MODULE_VERSION);
    tt = gs->started;
    strftime(ts, 60, "%d.%m. %Y  %H:%M", localtime(&tt));
    if (!today)
      fprintf(f, "Started %s<BR>", ts);
    if (webupdate > 0)
      fprintf(f, "This page autoupdates every %d minutes.<BR>", webupdate);
    fprintf(f, "</CENTER>");
    fprintf(f, "</body></html>");
    fclose(f);
    unlink(s2);
    movefile(s, s2);
  }
  write_graph_webstats(chan, today);
  ctime(&ttbuf); /* workaround for a bug in older eggdrops */
  Context;
}

static void write_graph_webstats(char *chan, int today)
{
  globstats *gs;
  locstats *ls;
  char what[512], *pwhat, *type, s[512], s2[512];
  char bground[140];
  FILE *f;
  int total, rest, width, max, itype, nr;
  float onep, percent, wpercent;
  struct userrec *u;
  
  Context;
  gs = findglobstats(chan);
  if (!gs) {
    putlog(LOG_MISC, "*", "Stats.mod: Can't graphs for %s, no stats found.", chan);
    return;
  }
  sprintf(s, "%s/%s%s_graphs%s%s~new", webdir, webfiles, chan + 1,
          today ? "_today" : "", webfile_suffix);
  sprintf(s2, "%s/%s%s_graphs%s%s", webdir, webfiles, chan + 1,
          today ? "_today" : "", webfile_suffix);
  f = fopen(s, "w");
  chmod(s, 0644);
  if (f == NULL) {
    putlog(LOG_MISC, "*", "ERROR writing graphs. (%s)", s);
    return;
  }
  if (graphgif[0] == 0)
    bground[0] = 0;
  else
    sprintf(bground, "background=\"%s\"", graphgif);
  if (webupdate > 0)
    fprintf(f, "<meta http-equiv=\"Refresh\" content=%d>\n", webupdate * 60);
  fprintf(f, "<!-- Created by Stats.mod v%s-->\n", MODULE_VERSION);
  fprintf(f, "<html><head><meta http-equiv=\"expires\" content=\"0\">\n");
  fprintf(f, "<title>Top %d statistics %son channel %s</title></head>\n", graphnr, today ? "for today " : "", chan);
  fprintf(f, "%s\n", bodytag);
  fprintf(f, "<center><h1>Top %d statistics %son channel %s</h1>\n", graphnr, today ? "for today " : "", chan);
  sprintf(what, "%s", graphstats);
  pwhat = what;
  while (strlen(pwhat) > 0) {
    type = newsplit(&pwhat);
    itype = typetoi(type);
    if (itype < 0) {
      putlog(LOG_MISC, "*", "Stats.mod: Error writing webfiles. Unsupported type %s. Skipping.", type);
      continue;
    }
    sortstats(gs, type, today);
    total = gettotal(gs, itype, today);
    rest = total;
    fprintf(f, "<br><br><br><table width=100%% border=1><tr><th width=100%% align=center><font size=+1>Ordered by <b>%s</b></font></td></tr></table>", type);
    fprintf(f, "<center><font size=-1>[%d %s total]</font></center><br>\n", total, type);
    if (gs->local)
      max = gs->local->values[today][itype];
    else {
      debug1("Stats.mod: Error writing graphs for %s, no local stats", chan);
      return;
    }
    fprintf(f, "<table width=100%%>\n");
    if (!total || !max)
      continue;
    onep = (float) total / 100.0;
    nr = 0;
    for (ls = gs->local; ls; ls = ls->next) {
      u = get_user_by_handle(userlist, ls->user);
      if (matchattr(u, nostats, chan))
        continue;
      if (!ls->values[today][itype])
        break;
      nr++;
      if (nr > graphnr)
        break;
      fprintf(f, "<tr>\n");
      percent = (float) ls->values[today][itype] / onep;
      wpercent = (float) ls->values[today][itype] / ((float) max / 100.0);
      width = (int) wpercent * 0.8;
      fprintf(f, "  <td align=right width=10%%>%s</td>\n", ls->user);
      fprintf(f, "  <td align=left width=90%%>\n");
      fprintf(f, "    <table width=100%%><tr>\n");
      fprintf(f, "      <td width=%d%% bgcolor=\"%s\" %s>&nbsp;</td>\n", width, graphcolor, bground);
      fprintf(f, "      <td align=left width=%d%%>%.2f%% <font size=-2>[%d]</font></td>\n", 100 - width, percent, ls->values[today][itype]);
      fprintf(f, "    </tr></table>\n");
      fprintf(f, "  </td>\n");
      fprintf(f, "</tr>\n");
      rest -= ls->values[today][itype];
    }
    fprintf(f, "<tr>\n");
    percent = (float) rest / ((float) total / 100.0);
    wpercent = (float) rest / ((float) max / 100.0);
    width = (int) wpercent * 0.8;
    fprintf(f, "  <td align=right width=10%%>[others]</td>\n");
    fprintf(f, "  <td align=left width=90%%>\n");
    fprintf(f, "    <table width=100%%><tr>\n");
    fprintf(f, "      <td width=%d%% bgcolor=\"%s\" %s>&nbsp;</td>\n", width, graphcolor, bground);
    fprintf(f, "      <td align=left width=%d%%>%.2f%% <font size=-2>[%d]</font></td>\n", 100 - width, percent, rest);
    fprintf(f, "    </tr></table>\n");
    fprintf(f, "  </td>\n");
    fprintf(f, "</tr></table>\n");
  }
  fprintf(f, "</table>\n");
  fprintf(f, "<br><center><a href=\"%s%s_words%s%s\">back</a><br>Created by <a href=\"http://www.visions-of-fantasy.de/stats.mod/\">Stats.mod v%s</a></center></body></html>",
          webfiles, chan + 1, today ? "_today" : "", webfile_suffix,
          MODULE_VERSION);
  fclose(f);
  unlink(s2);
  movefile(s, s2);
  Context;
}